﻿import { Injectable, Inject, Optional } from '@angular/core';

import * as tinymce from 'tinymce';

import { MaterialsWidthHelper } from 'ivy.angular.material.helpers';

@Injectable()
export class TinyMceConfigurationService {

    constructor(
        @Optional() @Inject('TinyEditorInlineConfiguration') private config: any,
        private matWidthHelper: MaterialsWidthHelper) {
    }


    generateConfigs(elementId: string, setupFn: (editor: tinymce.Editor) => void): tinymce.Settings {

        let tinyMceConfig: tinymce.Settings = {
            selector: '#' + elementId,
            inline: true,
            insert_toolbar: '',
            setup: setupFn,
            theme: 'modern'
        };

        if (this.matWidthHelper.isXs()) {
            tinyMceConfig.theme = 'inlite';
        }

        if (this.config) {

            let configKeys = Object.keys(this.config);

            for (var i = 0; i < configKeys.length; i++) {

                let key = configKeys[i];
                tinyMceConfig[key] = this.config[key];
            }
        }

        return tinyMceConfig;
    }
}